<template>
  <div id="tags-view-container" class="tags-view-container">
    <scroll-pane ref="scrollPane" class="tags-view-wrapper">
      <router-link
        v-for="tag in visitedViews"
        ref="tag"
        :key="tag.path"
        :class="isActive(tag)?'active':''"
        :to="{ path: tag.path, query: tag.query, fullPath: tag.fullPath }"
        tag="span"
        class="tags-view-item"
        @click.middle.native="closeSelectedTag(tag)"
        @contextmenu.prevent.native="openMenu(tag,$event)"
      >
        {{ generateTitle(tag.title) }}
        <span v-if="!tag.meta.affix" class="el-icon-close" @click.prevent.stop="closeSelectedTag(tag)" />
      </router-link>
    </scroll-pane>
    <ul v-show="visible" :style="{left:left+'px',top:top+'px'}" class="contextmenu">
      <li @click="refreshSelectedTag(selectedTag)">
        {{ $t('tagsView.refresh') }}
      </li>
      <li v-if="!(selectedTag.meta&&selectedTag.meta.affix)" @click="closeSelectedTag(selectedTag)">
        {{
          $t('tagsView.close') }}
      </li>
      <li @click="closeOthersTags">
        {{ $t('tagsView.closeOthers') }}
      </li>
      <li @click="closeAllTags(selectedTag)">
        {{ $t('tagsView.closeAll') }}
      </li>
    </ul>
    <el-dialog title="报警详情" :visible.sync="dialogTableVisible">
      <el-form ref="form" label-width="80px">
        <el-form-item label="设备编号">
          <span>{{ gridData.devicenum }}</span>
        </el-form-item>
        <el-form-item label="设备名称">
          <span>{{ gridData.username }}</span>
        </el-form-item>
        <el-form-item label="用户名称">
          <span>{{ gridData.name }}</span>
        </el-form-item>
        <el-form-item label="用户邮箱">
          <span>{{ gridData.email }}</span>
        </el-form-item>
        <el-form-item label="设备类型">
          <span>{{ gridData.tname }}</span>
        </el-form-item>
        <el-form-item label="设备单位浓度" label-width="100px">
          <span>{{ gridData.gas }}/{{ gridData.concentration }}{{ gridData.danwei }}</span>
        </el-form-item>
        <el-form-item label="设备报警开始时间" label-width="130px">
          <span>{{ gridData.starttime | parseTime('{y}-{m}-{d} {h}:{i}:{s}') }}</span>
        </el-form-item>
        <el-form-item label="报警位置">
          <span>{{ gridData.location }}</span>
        </el-form-item>
        <el-form-item label="设备坐标">
          <span>{{ gridData.devicecoord }}</span>
        </el-form-item>
        <el-form-item label="设备备注">
          <span>{{ gridData.deviceremark }}</span>
        </el-form-item>
        <el-form-item label="添加时间">
          <span>{{ gridData.deviceaddtime | parseTime('{y}-{m}-{d} {h}:{i}') }}</span>
        </el-form-item>
        <el-form-item label="设备报警状态" label-width="100px">
          <span>{{ gridData.status_name }}</span>
        </el-form-item>
      </el-form>
    </el-dialog>
  </div>
</template>

<script>
import ScrollPane from './ScrollPane';
import { generateTitle } from '@/utils/i18n';
import path from 'path';
import websocketurl from '@/api/configurl';
import { devicepolice, devicepoliceinfo } from '@/api/device';
export default {
  components: { ScrollPane },
  data() {
    return {
      visible: false,
      top: 0,
      tableKey: 0,
      dialogTableVisible: false,
      left: 0,
      timer: '',
      selectedTag: {},
      gridData: [],
      affixTags: [],
    };
  },
  computed: {
    visitedViews() {
      return this.$store.state.tagsView.visitedViews;
    },
    routes() {
      return this.$store.state.permission.routes;
    },
  },
  watch: {
    $route() {
      this.addTags();
      this.moveToCurrentTag();
    },
    visible(value) {
      if (value) {
        document.body.addEventListener('click', this.closeMenu);
      } else {
        document.body.removeEventListener('click', this.closeMenu);
      }
    },
  },
  created() {
    window.addEventListener('beforeunload', e => this.beforeun(e));
  },
  mounted() {
    this.initTags();
    this.addTags();
    this.initWebSocket(); // 返回报警
  },
  methods: {
    generateTitle, // generateTitle by vue-i18n
    isActive(route) {
      return route.path === this.$route.path;
    },
    filterAffixTags(routes, basePath = '/') {
      let tags = [];
      routes.forEach(route => {
        if (route.meta && route.meta.affix) {
          const tagPath = path.resolve(basePath, route.path);
          tags.push({
            fullPath: tagPath,
            path: tagPath,
            name: route.name,
            meta: { ...route.meta },
          });
        }
        if (route.children) {
          const tempTags = this.filterAffixTags(route.children, route.path);
          if (tempTags.length >= 1) {
            tags = [...tags, ...tempTags];
          }
        }
      });
      return tags;
    },
    initTags() {
      const affixTags = this.affixTags = this.filterAffixTags(this.routes);
      for (const tag of affixTags) {
        // Must have tag name
        if (tag.name) {
          this.$store.dispatch('tagsView/addVisitedView', tag);
        }
      }
    },
    addTags() {
      const { name } = this.$route;
      if (name) {
        this.$store.dispatch('tagsView/addView', this.$route);
      }
      return false;
    },
    initWebSocket() {
      const wsuri = websocketurl.alarmUrl;
      this.websock = new WebSocket(wsuri);
      this.websock.onmessage = this.websocketonmessage;
      this.websock.onopen = this.websocketonopen;
      this.websock.onerror = this.websocketonerror;
      this.websock.onclose = this.websocketclose;
    },
    websocketonopen(){ // 连接建立之后执行send方法发送数据
      this.timer = setInterval(() => {
        this.websocketsend();
      }, 5000);
    },
    websocketonerror(){ // 连接建立失败重连
      this.$notify({
        title: '警告',
        message: '建立链接失败,正在重连',
        type: 'warning',
      });
      this.initWebSocket();
    },
    websocketonmessage(e){ // 数据接收
      const that = this;
      const redata = JSON.parse(e.data);
      if (redata.code === 200) {
        if (localStorage.getItem('isalam') === null || localStorage.getItem('isalam') === undefined) { // 第一次没有的话
          localStorage.setItem('isalam', JSON.stringify(redata.data));
          for (let i = 0; i < redata.data.length; i++) {
            setTimeout(() => {
              this.$notify.error({
                title: '报警提示!点击X可消警',
                dangerouslyUseHTMLString: true,
                duration: 0,
                message: redata.data[i].devicenumber + '正在报警请尽快处理',
                onClose: function(){
                  devicepolice(redata.data[i].devicenumber)
                    .then(response => {
                      localStorage.removeItem('isalam');
                    })
                    .catch(err => {
                      console.log(err);
                    });
                },
                onClick: function(){
                  devicepoliceinfo(redata.data[i].devicenumber)
                    .then(response => {
                      that.gridData = response.data;
                      that.dialogTableVisible = true;
                    })
                    .catch(err => {
                      console.log(err);
                    });
                },
              });
            }, 3);
          }
        } else {
          for (let j = 0; j < redata.data.length; j++) {
            if (!this.isarray(redata.data[j].devicenumber, JSON.parse(localStorage.getItem('isalam')))) {
              setTimeout(() => {
                this.$notify.error({
                  title: '报警提示!点击右侧x可消警',
                  dangerouslyUseHTMLString: true,
                  duration: 0,
                  message: redata.data[j].devicenumber + '正在报警请尽快处理',
                  onClose: function(){
                    devicepolice(redata.data[j].devicenumber)
                      .then(response => {
                        localStorage.removeItem('isalam');
                      })
                      .catch(err => {
                        console.log(err);
                      });
                  },
                  onClick: function(){
                    devicepoliceinfo(redata.data[j].devicenumber)
                      .then(response => {
                        that.gridData = response.data;
                        that.dialogTableVisible = true;
                      })
                      .catch(err => {
                        console.log(err);
                      });
                  },
                });
              }, 3);
              localStorage.setItem('isalam', JSON.stringify(redata.data));
            }
          }
        }
      }
    },
    beforeun(e) {
      localStorage.removeItem('isalam');
    },
    closeAlls() {
      this.$notify.closeAll();
    },
    websocketsend(){ // 数据发送
      this.websock.send(localStorage.getItem('userinfoid'));
    },
    websocketclose(e){ // 关闭
      console.log('断开连接', e);
      this.$notify({
        title: '警告',
        message: '监测报警长连接已断开',
        type: 'warning',
      });
      clearInterval(this.timer);
    },
    isarray(needle, arr) { // data长连接返回 adata本地储
      var has = false;
      for (let i = 0; i < arr.length; i++) {
        if (arr[i].devicenumber === needle) {
          return true;
        }
      }
      return has;
    },
    moveToCurrentTag() {
      const tags = this.$refs.tag;
      this.$nextTick(() => {
        for (const tag of tags) {
          if (tag.to.path === this.$route.path) {
            this.$refs.scrollPane.moveToTarget(tag);
            // when query is different then update
            if (tag.to.fullPath !== this.$route.fullPath) {
              this.$store.dispatch('tagsView/updateVisitedView', this.$route);
            }
            break;
          }
        }
      });
    },
    refreshSelectedTag(view) {
      this.$store.dispatch('tagsView/delCachedView', view).then(() => {
        const { fullPath } = view;
        this.$nextTick(() => {
          this.$router.replace({
            path: '/redirect' + fullPath,
          });
        });
      });
    },
    closeSelectedTag(view) {
      this.$store.dispatch('tagsView/delView', view).then(({ visitedViews }) => {
        if (this.isActive(view)) {
          this.toLastView(visitedViews);
        }
      });
    },
    closeOthersTags() {
      this.$router.push(this.selectedTag);
      this.$store.dispatch('tagsView/delOthersViews', this.selectedTag).then(() => {
        this.moveToCurrentTag();
      });
    },
    closeAllTags(view) {
      this.$store.dispatch('tagsView/delAllViews').then(({ visitedViews }) => {
        if (this.affixTags.some(tag => tag.path === view.path)) {
          return;
        }
        this.toLastView(visitedViews);
      });
    },
    toLastView(visitedViews) {
      const latestView = visitedViews.slice(-1)[0];
      if (latestView) {
        this.$router.push(latestView);
      } else {
        // You can set another route
        this.$router.push('/');
      }
    },
    openMenu(tag, e) {
      const menuMinWidth = 105;
      const offsetLeft = this.$el.getBoundingClientRect().left; // container margin left
      const offsetWidth = this.$el.offsetWidth; // container width
      const maxLeft = offsetWidth - menuMinWidth; // left boundary
      const left = e.clientX - offsetLeft + 15; // 15: margin right

      if (left > maxLeft) {
        this.left = maxLeft;
      } else {
        this.left = left;
      }

      this.top = e.clientY;
      this.visible = true;
      this.selectedTag = tag;
    },
    closeMenu() {
      this.visible = false;
    },
  },
};
</script>

<style lang="scss" scoped>
.tags-view-container {
  height: 34px;
  width: 100%;
  background: #fff;
  border-bottom: 1px solid #d8dce5;
  box-shadow: 0 1px 3px 0 rgba(0, 0, 0, .12), 0 0 3px 0 rgba(0, 0, 0, .04);
  .tags-view-wrapper {
    .tags-view-item {
      display: inline-block;
      position: relative;
      cursor: pointer;
      height: 26px;
      line-height: 26px;
      border: 1px solid #d8dce5;
      color: #495060;
      background: #fff;
      padding: 0 8px;
      font-size: 12px;
      margin-left: 5px;
      margin-top: 4px;
      &:first-of-type {
        margin-left: 15px;
      }
      &:last-of-type {
        margin-right: 15px;
      }
      &.active {
        background-color: #42b983;
        color: #fff;
        border-color: #42b983;
        &::before {
          content: '';
          background: #fff;
          display: inline-block;
          width: 8px;
          height: 8px;
          border-radius: 50%;
          position: relative;
          margin-right: 2px;
        }
      }
    }
  }
  .contextmenu {
    margin: 0;
    background: #fff;
    z-index: 3000;
    position: absolute;
    list-style-type: none;
    padding: 5px 0;
    border-radius: 4px;
    font-size: 12px;
    font-weight: 400;
    color: #333;
    box-shadow: 2px 2px 3px 0 rgba(0, 0, 0, .3);
    li {
      margin: 0;
      padding: 7px 16px;
      cursor: pointer;
      &:hover {
        background: #eee;
      }
    }
  }
}
</style>

<style lang="scss">
//reset element css of el-icon-close
.tags-view-wrapper {
  .tags-view-item {
    .el-icon-close {
      width: 16px;
      height: 16px;
      vertical-align: 2px;
      border-radius: 50%;
      text-align: center;
      transition: all .3s cubic-bezier(.645, .045, .355, 1);
      transform-origin: 100% 50%;
      &:before {
        transform: scale(.6);
        display: inline-block;
        vertical-align: -3px;
      }
      &:hover {
        background-color: #b4bccc;
        color: #fff;
      }
    }
  }
}
</style>
